var defaultData = {
	category : "replace into category(id,v) select 11,'[717,5,701,2022,2021,722,110,716,2026,1009,1011,715,721,719,2028,2027,2014,2018,1012,13,2016,2023,2013,353,2,708,106,345,347]' union all select 12,'[2011,1010,100625615,3001,100621162,100631344,801008384,1,3,4,8]' union all select 13,'[1000,6,14,2007,2002,2006,2004,12]' union all select 14,'[717,5,701,2022,2021,722,110,716,2026,1009,1011,715,721,719,2028,2027,2014,2018,1012,13,2016,2023,2013,353,2,708,106,345,347]' union all select 15,'[717,5,701,2022,2021,722,110,716,2026,1009,1011,715,721,719,2028,2027,2014,2018,1012,13,2016,2023,2013,353,2,708,106,345,347]'",
	apps : '',
	lastUpdateTime : "1348106890592"
};

var cp = log = function(){};


var system = {
	client: window.QzoneAppCenter,
	db : {
		engine : window.qzone_db,
		init : function() {
			// 创建分类表
			var cateSql = "create table category (id INTEGER PRIMARY KEY,v text);";
			if (this.engine) {
				if (this.engine.createTable("category", cateSql, 2) == 0) {
					// 第一次创建成功，插入默认数据
					if (defaultData && defaultData.category)
						this.engine.exec(defaultData.category);
				}
			}
			// 创建应用表
			var appSql = "create table app (id INTEGER PRIMARY KEY,v text,imid varchar(30));";
			if (this.engine) {
				if (this.engine.createTable("app", appSql, 5) == 0) {
					// 第一次创建成功，插入默认数据
					if (defaultData && defaultData.apps) {
						if (this.engine.exec(defaultData.apps) == 0) {
							// 保存最后更新时间
							system.storage.setItem("app_lastupdate", defaultData.lastUpdateTime);
						}
					}
				}
			}
			var pictureSql = "create table image (id INTEGER PRIMARY KEY,v text);";
			this.engine && this.engine.createTable("app", appSql, 5);
			//this.engine && this.engine.exec(pictureSql);
		},
		addApp : function(id, v, imid) {
			if (typeof v == "object")
				v = $.stringify(v);
			var sql = "replace into app(id,v,imid) values(" + id + ",'" + v + "','" + imid + "');"; //q_storage._replaceSql(v)
			if (this.engine) {
				this.engine.exec(sql);
			}
		},
		getAppById : function(id) {
			var sql = "select v from app where id=" + id;
			if (this.engine) {
				var data = this.engine.select(sql);
				if (typeof data == "object") {
					data = String(data);
				}
				var jsonData = $.parseJSON(data);
				if (jsonData && jsonData.length > 0) {
					// 取第一行，第1列，就是v的值,仍然返回json
					var v = jsonData[0][0];
					v = $.parseJSON(v);
					return v;
				}
			}

			return null;
		},
		getAppByImId : function(imid) {
			var sql = "select v from app where imid=" + imid + "";
			if (this.engine) {
				var data = this.engine.select(sql);
				if (typeof data == "object") {
					data = String(data);
				}
				var jsonData = $.parseJSON(data);
				if (jsonData && jsonData.length > 0) {
					var v = jsonData[0][0];
					return $.parseJSON(v);
				}
			}

			return null;
		},
		getImage: function(id){
			var sql = "select v from image where id=" + id;
			if (this.engine) {
				var data = this.engine.select(sql);
				if (typeof data == "object") {
					data = String(data);
				}
				var jsonData = $.parseJSON(data);
				if (jsonData && jsonData.length > 0) {
					var v = jsonData[0][0];
					v = $.parseJSON(v);
					return v;
				}
			}
			return null;
		},
		updateImage: function(id,v){
			var sql = "replace into image(id,v) values(" + id + ",'" + v + "');";
			if (this.engine) {
				this.engine.exec(sql);
			}
		}
	}, // db

	/**
	 * 下载及进度控制
	 */
	download : {
		count : 0,
		engine : window.q_download,
		cargo : {},
		backQuque : [], // 状态队列
		doingQuque : false, // 正在处理标识
		timeId : -1,
		onStateChange: function(){},
		// 回调(state: 1:初始化,2:下载中,3:暂停,4:下载完成,5:安装,6:安装完成)
		// data = {"appid":0,"pro":0.5,"state":2,"url":""}
		listened : function(data) {
			if (data.length) {
				for (var i in data) {
					var appid = data[i].appid;
					if(this.cargo[appid] && this.cargo[appid].pro == 0 && data[i].pro == 100) return; //禁止从0直接蹦到100, 规避来自终端的一个bug
					this.cargo[appid] = data[i];
					this.callback.call(this, data[i]);
				}
			} else {
				var appid = data.appid;
				if(this.cargo[appid] && this.cargo[appid].pro == 0 && data.pro == 100) return; //禁止从0直接蹦到100, 规避来自终端的一个bug
				this.cargo[appid] = data;
				this.callback.call(this, data);
			}
		},
		callback : function(data, isFromQuery) {
			// 回调(state: 1:初始化,2:下载中,3:暂停,4:下载完成,5:安装,6:安装完成,
			// -1:错误(比如包名变了),-2:下载过程出错,-3:sd卡拔出或内存满了,-4:下载过程中URL变了
			//data = {"appid":600,"pro":5,"state":2,"phony_pro":"5.6",sendtime:'1352391527410000'};
			// 先push到队列
			this.backQuque.push({"data" : data, "isFromQuery" : isFromQuery});
			if (!system.download.doingQuque) {
				var d = system.download.backQuque.shift();
				this._showState(d.data, d.isFromQuery);
			}
		},
		registerListener : function() { // 将下载进度回调注册到终端, 这一过程只执行一次
			if (this.engine && this.engine.registerDownloadCallBackListener) {
				this.engine.registerDownloadCallBackListener("system.download.listened");
			}
		},
		// 查询状态(appidList:jsonarray的字符串)
		query : function(apps, isUpdate) {
			if (this.engine && this.engine.getQueryDownloadAction) {
				// 查询正式进度
				var queryData = this.engine.getQueryDownloadAction(apps, isUpdate);
				//cp(queryData)
				if (typeof queryData == "object") {
					queryData = $.stringify(queryData);
				}
				var jsonData = $.parseJSON(queryData);
				for (var i = 0; i < jsonData.length; i++) {
					var tmpData = jsonData[i];
					if (tmpData.pro >= 100) // 处理错误,防止android代码错误
						tmpData.state = 4;
					this.cargo[tmpData.appid] = tmpData;
					this.callback.call(this, tmpData, true);
				}
			} else {
			}
		},
		cancel: function(appid, sendtime) {
			if(this.cargo[appid]) {
				this.cargo[appid].state = 1;
				this.cargo[appid].pro = 0;
				this.cargo[appid].phony_pro = 0;
				this.cargo[appid].sendtime = '';
				this.cargo[appid].canceled = true;
			}
			var $download = $('#download-' + sendtime);
			var state = $download.attr('state');
			if(state == '2' || state == '3' || state == '4'){ // 正在下载、正在暂停、或者下载已完成时
				this._setText(appid, '', $download.attr('outdated') == 'yes' ? '更新' : '下载', 0, 1); // 不给sendtime表示 重置或更新所有按钮
			}
			$download.attr('canceled', '1'); // 不允许再更新状态
			$('.ignore[appid="' + appid + '"]').removeClass('download-cancel').text('忽略');
			this.engine.cancelDownload(appid, '' + sendtime);
		},
		handleButtonClick : function(app, options) {
			var $button = $(options.button);
			if ($button.hasClass('installed') && $button.attr('outdated') != 'yes') {
				system.client.startApp(app.packagename, app.apkurl || app.fixpackageurl, app.typeid);

				reportForVia(500, getViaFromType(app.typeid), app.appid); // 启动上报
				return true;
			}
			var downloading = this.cargo[app.appid];
			if (!downloading || downloading.state == 4) { // 新建一个downloading
				downloading = {
					appid : app.appid,
					pro : 0,
					state : 1,
					sendtime: '' + app.sendtime,
					phony_pro : 0
				};
				this.cargo[app.appid] = downloading;
			}
			var state = $button.attr('state');
			//cp('state' + state)
			$button.attr('canceled', 0);
			var sendtime = $button.attr('id').replace('download-', '');
			var apkurl = app.apkurl || app.fixpackageurl;
			// console.log('handleButtonClick appid ' + app.appid + 'state ' + state);
			if (state == 1 || state == 3 || state < 0) {
				if(!checkNetwork()) {
					toast('网络中断, 无法下载');
					return false;
				}
				if(!checkSD()) {
					toast('无SD卡或空间不足，已暂停下载');
					if(downloading.state == 2) downloading.state = 3;
					this.callback.call(this, downloading);
					return false;
				}
				downloading.state = 2;
				$(options.button).attr('state', 2);
				if(app.appid == downloading.appid && downloading.sendtime.indexOf(sendtime) == -1) { //将按钮加入到下载进度队列
					downloading.sendtime += (downloading.sendtime ? ',' : '') + sendtime;
				}
				//cp(downloading.pro + '*' + downloading.phony_pro)
				this.callback.call(this, downloading);
				/**
				 * actionCode是12的条件:
				＊没有同一appid在下载
				 * state为初始值1
				 **/
				var _actionCode = state == 1 && ($button.attr('outdated') == 'yes' || $button.attr('downloaded') == 'low') ? 12 : 2;
				var _actionType = state == 1 && ($button.attr('outdated') == 'yes') ? 2000 : 900;
				var o = {
						appid: app.appid + '',
						url: apkurl,
						packageName: app.packagename,
						actionCode: _actionCode,
						via: options.via,
						appName: options.title,
						dType: options.auto,
						notifyKey: 'N' + app.sendtime,
						actionType: _actionType,
						gf: '',
						from: '0'
					};
				//console.log('download doDownloadAction : o ' + $.stringify(o));
				this.engine.doDownloadAction($.stringify(o));
			} else if (state == 2) { // 下载进行时继续
				var o = {
						appid: app.appid + '',
						url: apkurl,
						packageName: app.packagename,
						actionCode: 3,
						via: options.via,
						appName: options.title,
						dType: options.auto,
						notifyKey: 'N' + app.sendtime,
						actionType: 900,
						gf: '',
						from: '0'
					};
				downloading.state = 3;
				// console.log('download doDownloadAction : o ' + $.stringify(o));
				this.engine.doDownloadAction($.stringify(o));
			} else if (state == 4) { // 安装
				var o = {
					appid: app.appid + '',
					url: apkurl,
					packageName: app.packagename,
					actionCode: 5,
					via: options.via,
					appName: options.title,
					dType: options.auto,
					notifyKey: 'N' + app.sendtime,
					actionType: 900,
					gf: '',
					from: '0'
				};
				// console.log('download doDownloadAction : o ' + $.stringify(o));
				this.engine.doDownloadAction($.stringify(o));
			} else if (state == 6) {
				return true;
			}
			return false;
		},
		_showState : function(data, isFromQuery) {
			this.doingQuque = true;
			if (data.phony_pro > data.pro) data.pro = data.phony_pro;
			if (data.state == 2) {
				this._setText(data.appid, data.sendtime, parseInt(data.pro) + '%', data.pro, 2);
				//this._showProInc(data.appid, data.sendtime, data.pro);
				this.doingQuque = false;
				return;
			} else {
				clearTimeout(this.timeId);
				if (data.state == 3 && data.pro > 0) {
					this._setText(data.appid, data.sendtime, "继续", data.pro, 3);
				}
				if (data.state < 0 || data.state == 1) {
					if (data.state == -1) {
						toast("安装包损坏，请重新下载");
						this._setText(data.appid, data.sendtime, "下载", "0", 1);
					} else if (data.state == -2) {
						if (isFromQuery) { // 查询的时候不提示错误
							toast("下载出错，已暂停下载");
						}
						if (data.pro > 0) { // 下载到一半出问题
							this._setText(data.appid, data.sendtime, '继续', data.pro, 3);
							this._continueShow();
							return;
						}
						this._setText(data.appid, data.sendtime, '继续', '0', 3);
					} else if (data.state == -3) {
						toast("无SD卡或空间不足，已暂停下载");
						this._setText(data.appid, data.sendtime, '继续', data.pro, 3);
					} else if (data.state == -4) {
						toast("下载地址已更新, 请重新下载");
						this._setText(data.appid, data.sendtime, "下载", "0", 1);
					}
				} else if (data.state == 4) { //// 检测到新包刚刚下载完成时 这里需要考虑是刚刚下载完, 还是页面刷新回来的
					var $button = this._getButton(data.appid, data.sendtime);
					if($button.hasClass('installed')) { // 已安装
						if($button.attr('outdated') == 'yes') { // 并且外网有更新版本
							if($button.attr('downloaded') != 'up') { // 下载完成的是旧版本安装包
								this._setText(data.appid, data.sendtime, "更新", 0, 1);
								$button.cancelButton.removeClass('download-cancel').html('忽略');
							} else {
								this._setText(data.appid, data.sendtime, "安装", 0, 4);
								$button.cancelButton.addClass('download-cancel').html('取消');
							}
						}else { // 并且安装的是最新版本
							this._setText(data.appid, data.sendtime, "打开", 0, 6);
							$button.cancelButton.removeClass('download-cancel').html('忽略');
						}
					} else { // 原先未安装
						if($button.attr('downloaded') != 'up') {
							this._setText(data.appid, data.sendtime, "下载", 0, 1);
						} else {
							this._setText(data.appid, data.sendtime, "安装", 100, 4);
							$button.cancelButton.addClass('download-cancel').html('取消');
						}
					}
				} else if (data.state == 6) {
					if(data.sendtime) { //安装成功时删除消息
						__dismiss(data.sendtime);
					}
				}
			}
			this._continueShow(); // 继续显示其他的
		},
		_getButton: function(appid, sendtime){
			var $button;
			if(sendtime){
				var sendtimes = ('' + sendtime).split(','), ids = [];
				for(var i = 0; i<sendtimes.length; i ++) {
					ids.push('#download-' + sendtimes[i]);
				}
				$button = $(ids.join(','));
				var ignIds = [];
				$button.each(function () {
					ignIds.push('#' + this.id.replace(/download-/gi, 'ignore-'));
				});
				$button.cancelButton = $(ignIds.join(','));
			}else {
				$button = $('.download[appid="' + appid + '"]');
				$button.cancelButton = $('.ignore[appid="' + appid + '"]');
			}
			return $button;
		},
		_setText : function(appid, sendtime, text, pro, state) {

			//console.log('_setText appid : ' + appid + ' sendtime : ' + sendtime + ' text : ' + text + ' pro : ' + pro + ' state' + state);

			var $button = this._getButton(appid, sendtime);
			if($button.length == 0) return false;
			if($button.attr('canceled') == '1') {
				return false;
			}
			var nowpercent = parseInt($button.find('.text').text());
			if(state){
				$button.attr('state', state);
			}
			if(!isNaN(nowpercent) && pro < nowpercent && pro - nowpercent > -2) { // 仅当设置数小于已显示进度时更改。避免引起进度后退的现象。
				return false;
			}
			$button.find('.pro').css("width", pro + '%');
			$button.find('.text').show().text(text);
			if(state != 1 && state != 12) {
				$button.cancelButton.addClass('download-cancel').html('取消');
			}
			this.onStateChange(appid, sendtime, state); // 通知用户界面下载状态更新
		},
		_continueShow : function() {
			if (this.backQuque.length > 0) {
				var d = this.backQuque.shift();
				this._showState(d.data, d.isFromQuery);
			} else {
				this.doingQuque = false;
			}
		},
		_getSize : function(size) {
			if (!size)
				size = "8M";
			var intSize = parseFloat(size);
			if (size.indexOf("M") != -1)
				intSize = intSize * 1024;
			return intSize;
		}
	}, //db

	cache : {
		engine : window.qzone_imageCache,
		SD_PATH : null,
		APP_PATH : null,
		path : "app",
		SD_IS_OK : true,

		init : function() {
			if (this.engine) {
				var rootPath = this.engine.getImageRootPath();
				if (typeof rootPath == "object") {
					rootPath = String(rootPath);
				}
				this.SD_PATH = "file:////" + rootPath;
				this.APP_PATH = "file:////" + rootPath + this.path + "/";
				if (this.engine.sdIsMounted() != 0) {
					this.SD_IS_OK = false;
					if(location.href.match(/apps\.html/) == null) { // apps.html消息页不报告SD卡问题
						toast('当前SD卡被拔出, 图片可能无法正常显示');
					};
				}
			}
		},
		getCache : function(appid, logo) {
			if (this.APP_PATH)
				return this.APP_PATH + logo;
			else
				return "http: //3glogo.gtimg.com/images/qzone_app/logo/" + logo;
		},
		updateImage : function(appid, logo, callback) {
			if (callback == null)
				callback = "";
			//appid = transIntData(appid);
			if (this.engine && this.SD_IS_OK)
				this.engine.downloadImage(appid, this.path, "http: //3glogo.gtimg.com/images/qzone_app/logo/" + logo, callback);
		},
		download : function(appid, path, url, callback) {
			if (callback == null)
				callback = "";
			//appid = transIntData(appid);
			this.callback = callback;
			if (this.engine && this.SD_IS_OK)
				this.engine.downloadImage(appid, path, url, 'system.cache.callback');
		},
		check : function(appid, path, url) {
			if (this.engine) {
				//appid = transIntData(appid);
				return (this.engine.imageIsExist(appid, path, url) == 0);
			}
			return false;
		},
		callback : function() {
			
		}
	}, // cache

	storage : {
		db : window.qzone_db,
		version : 1,
		table_name : "app_cache",
		init : function() {
			var createSql = "create table " + this.table_name + " (k varchar(50) PRIMARY KEY, v text);";
			if (this.db) {
				var ret = this.db.createTable(this.table_name, createSql, this.version);
				if (ret == 0) {
					try {
						var uin = window.QzoneAppCenter.getUin();
						var v = window.QzoneAppCenter.getItem("play_" + uin);
						if (v) {
							if (typeof v == "object") {
								v = String(v);
							}
							var apps = $.parseJSON(v);
							var myPlay = [];
							if (typeof apps != "undefined" && apps != null) {
								for (var i in apps) {
									var appid = apps[i][0];
									myPlay.push(appid);
								}
							}
							q_storage.setItem("play_" + uin, myPlay);
						}
					} catch (e) {
					}
				}
			}
		},
		getItem : function(key) {
			var sql = "select k, v from " + this.table_name + " where k='" + key + "'";
			if (this.db) {
				var data = this.db.select(sql);
				if (typeof data == "object") {
					data = String(data);
				}
				var jsonData = $.parseJSON(data);
				if (jsonData && jsonData.length > 0) {
					return jsonData[0][1];
				}
			}
			return null;
		},
		setItem : function(key, value) {
			if (typeof value == "object")
				value = $.stringify(value);
			else if (typeof value != "string")
				value = new String(value);

			var sql = "replace into " + this.table_name + "(k, v) values('" + key + "', '" + this._replaceSql(value) + "');";
			if (this.db) {
				this.db.exec(sql);
			}
		},
		removeItem : function(key) {
			var sql = "delete " + this.table_name + " where k='" + key + "'";
			if (this.db) {
				this.db.exec(sql);
			}
		},
		_replaceSql : function(s) {
			return s.replace(/'/g, "''");
		}
	}, // db
	onresume: function(){}
}; // var system = ...

system.storage.init();
system.db.init();
system.cache.init();

$(window).bind('load', function(){
	if(false){
		$(document.body).append('<textarea id="consolep" count="1" style="position:absolute;bottom:0px;border:0;font-size:6pt;width:100%;position:fixed;height:4em;"></textarea>');
		cp = function(t){
			var count = $('#consolep').attr('count');
			$('#consolep').attr('count', parseInt(count) + 1);
			$('#consolep').val($('#consolep').val() +' #' + count + '^ ' + $.stringify(t));
			//$('#consolep').val(' #' + count + '^ ' + $.stringify(t));
		};
		log = function(t) {
			console.log('--macxu--' + $.stringify(t));
		};
		window.onerror = function(e) {
			cp(e);
		}
	}
});

window.onPageReady = function(){ // 等待条件满足时调用
	system.download.registerListener(); 
};






