var utils = {
	jsonp: function(url, onsuccess, onerror){
		$("#jsonp").remove();
		window._Callback = onsuccess;
		window._OnError = onerror || function(){};
		var script =document.createElement("script");
		script.setAttribute("type", "text/javascript");
		script.setAttribute("async", "async");
		script.setAttribute("defer", "defer");
		script.setAttribute("src",url);
		script.setAttribute("id", "jsonp");
		script.setAttribute("onerror", "window._OnError();");
		document.body.appendChild(script);
	},
	
	formatTime: function(milliseconds) {
		var diff = parseInt((window.__responedTime - milliseconds) / 1000), now = new Date(), theDate = new Date(milliseconds);
		/*
		if (diff < 5) {
			return "5秒前";
		}
		if (diff < 60) {
			return diff + "秒前";
		}
		*/		
		if (diff < 60) {
			return "刚刚";
		}
		if (diff < 60 * 60) {
			return parseInt(diff / 60) + "分钟前";
		}
		if (diff < 60 * 60 * 3) {
			return parseInt(diff / (60 * 60)) + "小时前";
		}
		if (now.getDate() === theDate.getDate()) {
			return "今天 " + theDate.getHours() + ":" + (theDate.getMinutes() < 10 ? '0' : '') + theDate.getMinutes();
		}
		if (new Date(now.getTime() - 24 * 60 * 60 * 1000).getDate() === theDate.getDate()) {
			return "昨天 " + theDate.getHours() + ":" + (theDate.getMinutes() < 10 ? '0' : '') + theDate.getMinutes();
		}
		if (now.getFullYear() === theDate.getFullYear()) {
			return (theDate.getMonth() + 1) + "月" + theDate.getDate() + "日";
		}
		return theDate.getFullYear() + "年" + (theDate.getMonth() + 1) + "月" + theDate.getDate() + "日";
	}
};


var params = null;
function getParam(key){
	if(!params){
		params = {};
		var search = location.search;
		if(search){
			search = search.substr(1);
		}else{
			search = system.client ? system.client.getParams() : {};
			if(typeof search == "object")
				search = String(search);
		}
		var splitSearch = search.split("&");
		for(var i in splitSearch){
			var kv = splitSearch[i].split("=");
			params[kv[0]] = decodeURIComponent(kv[1]);
		}
	}
	return params[key] || '';
}

function toast(message) {
	if (system.client) {
		system.client.showToast(message);
	}
}

function report(cgi, time, code) {
	system.client.cgiReport && system.client.cgiReport(cgi, time, code);
}

function checkNetwork() {
	if(typeof system.client.getNetworkStatus != 'function')
		return true;
	if(system.client.getNetworkStatus() == false || system.client.getNetworkStatus() == 'false') 
		return false;
	return true;
}

function checkSD(){
	return system.cache.engine.sdIsMounted() == 0;
}

var _pf = '';
function getPlatfrom() {
	!_pf && (_pf = getParam('platform')); // androidqz or androidqq
	return _pf ? _pf.toUpperCase() : 'ANDROIDQZ';
}

function getChannelVia(channelId) {
	var via = ({
		1: '.STORE.ASSISTANT.FREEGIFT.PUSH', 
		50: '.STORE.ASSISTANT.REQUEST.PUSH', 
		52: '.STORE.ASSISTANT.BRAG.PUSH', 
		53: '.STORE.ASSISTANT.PK.PUSH', 
		100: '.STORE.ASSISTANT.INVITE.PUSH', 
		56: '.STORE.ASSISTANT.PCPUSH.NOTIFY.PUSH', 
		57: '.STORE.ASSISTANT.PCPUSH.AUTO.PUSH',
		10000: '.STORE.ASSISTANT.MYQZ'
	})[channelId] || '';
	return getPlatfrom() + via || '';
}

function reportForVia(action, via, appid) {
	var repObj = {
		actionType: action,
		via: via,
		appid: (appid || 100) + ''
	};
	//console.log('reportForVia : '+$.stringify(repObj), repObj);
	QzoneAppCenter.reportForVia && QzoneAppCenter.reportForVia($.stringify(repObj));
	return true;
}

function getViaFromType(type) {
	// 社交渠道feeds跳转到应用详情页的上报需要在应用Tab里面进行修改上报
	var via = ({
		1:'.FREEGIFT.ASSISTANT', 
		50: '.REQUEST.ASSISTANT', 
		52: '.BRAG.ASSISTANT', 
		53: '.PK.ASSISTANT', 
		100: '.INVITE.ASSISTANT', 
		56:'.PCPUSH.NOTIFY', 
		57:'.PCPUSH.AUTO'
	})[type] || '';
	return getPlatfrom() + via || '';
}

function getIcon(appid) {
	return ['http://i.gtimg.cn/open/app_icon/',
		('00000000' + appid).substr(-8).match(/\d{2}/g).join('/'),
		'/'
	].join('');
}


